<mat-card class="m-5 mat-elevation-z4">
  <mat-card-header>
    <mat-card-title>Analyse</mat-card-title>
  </mat-card-header>

  <form [formGroup]="formGroup" (ngSubmit)="submitForm()">
    <mat-card-content>
      <mat-divider inset="true"></mat-divider>
      <mat-progress-bar
        mode="indeterminate"
        [ngStyle]="{ visibility: loading ? 'visible' : 'hidden' }"
        class="mb-3"
      ></mat-progress-bar>
      <div class="">
        <div class="border">
          <p-table
            [autoLayout]="true"
            [value]="criteres"
            [paginator]="true"
            [rows]="5"
            [showCurrentPageReport]="true"
            currentPageReportTemplate="Showing {first} to {last} of {totalRecords} entries"
            [rowsPerPageOptions]="[5, 10, 25]"
            sortField="type"
            sortMode="single"
            (onSort)="onSort()"
            styleClass="p-datatable-gridlines p-datatable-sm "
          >
            <ng-template pTemplate="header">
              <tr>
                <th rowspan="2" style="text-align: center">Critère</th>
                <th rowspan="2" style="text-align: center">Observations</th>
                <ng-container *ngIf="auditReceived == undefined">
                  <th colspan="5" style="text-align: center">Démérites</th>
                  <th rowspan="2" style="text-align: center">Total</th>
                </ng-container>
              </tr>
              <tr *ngIf="auditReceived == undefined">
                <th style="text-align: center">20</th>
                <th style="text-align: center">10</th>
                <th style="text-align: center">5</th>
                <th style="text-align: center">3</th>
                <th style="text-align: center">1</th>
              </tr>
            </ng-template>
            <ng-template pTemplate="body" let-critere let-rowIndex="rowIndex">

              <tr *ngIf="rowGroupMetadata[critere.type].index === rowIndex">
                <td colspan="8" class="bg-blue-50">
                  <span class="font-medium">{{ critere.type }}</span>
                </td>
              </tr>
              <tr>
                <td>{{ critere.nomCritere }}</td>
                <td>
                  <div [ngSwitch]="critere.typeObservation">
                    <!-- --------------------------------- dim --------------------------------- -->

                    <div *ngSwitchCase="'Dim'" class="flex justify-evenly">
                      <mat-form-field formGroupName="{{ critere.critereId }}">
                        <ng-container formArrayName="valueCritere">
                          <ng-container
                            *ngFor="
                              let control of valuesCritere(critere.critereId)
                                .controls;
                              index as i
                            "
                          >
                            <input
                              matInput
                              placeholder="{{
                                critere.typeObservation.split(';')[i]
                              }}"
                              type="number"
                              required
                              [formControlName]="i"
                            />
                          </ng-container>
                        </ng-container>
                      </mat-form-field>
                    </div>

                    <!-- -------------------------------- OKNOK -------------------------------- -->

                    <div
                      *ngSwitchCase="'OKNOK'"
                      formGroupName="{{ critere.critereId }}"
                    >
                      <ng-container formArrayName="valueCritere">
                        <ng-container
                          *ngFor="
                            let control of valuesCritere(critere.critereId)
                              .controls;
                            index as i
                          "
                        >
                          <mat-radio-group
                            [color]="'primary'"
                            required
                            [formControlName]="i"
                          >
                            <div class="flex justify-evenly">
                              <mat-radio-button value="OK" required name="OKNOK">OK</mat-radio-button>
                              <mat-radio-button value="NOK" name="OKNOK"
                                >NOK</mat-radio-button
                              >
                            </div>
                          </mat-radio-group>
                        </ng-container>
                      </ng-container>
                    </div>
                    <!-- -------------------------------- Nombre -------------------------------- -->

                    <div *ngSwitchCase="'Nombre'" class="flex justify-evenly">
                      <mat-form-field formGroupName="{{ critere.critereId }}">
                        <ng-container formArrayName="valueCritere">
                          <ng-container
                            *ngFor="
                              let control of valuesCritere(critere.critereId)
                                .controls;
                              index as i
                            "
                          >
                            <input
                              matInput
                              type="number"
                              placeholder="{{
                                critere.typeObservation.split(';')[i]
                              }}"
                              required
                              [formControlName]="i"
                            />
                          </ng-container>
                        </ng-container>
                      </mat-form-field>
                    </div>
                    <!-- -------------------------------- Valeur -------------------------------- -->

                    <div *ngSwitchCase="'Valeur'" class="flex justify-evenly">
                      <mat-form-field formGroupName="{{ critere.critereId }}">
                        <ng-container formArrayName="valueCritere">
                          <ng-container
                            *ngFor="
                              let control of valuesCritere(critere.critereId)
                                .controls;
                              index as i
                            "
                          >
                            <input
                              matInput
                              type="number"
                              placeholder="{{
                                critere.typeObservation.split(';')[i]
                              }}"
                              required
                              [formControlName]="i"
                            /> </ng-container
                        ></ng-container>
                      </mat-form-field>
                    </div>
                    <!-- -------------------------------- Réf -------------------------------- -->

                    <div *ngSwitchCase="'Réf'" class="flex justify-evenly">
                      <mat-form-field formGroupName="{{ critere.critereId }}">
                        <ng-container formArrayName="valueCritere">
                          <ng-container
                            *ngFor="
                              let control of valuesCritere(critere.critereId)
                                .controls;
                              index as i
                            "
                          >
                            <input
                              matInput
                              type="number"
                              placeholder="{{
                                critere.typeObservation.split(';')[i]
                              }}"
                              required
                              [formControlName]="i"
                            /> </ng-container
                        ></ng-container>
                      </mat-form-field>
                    </div>
                    <!-- -------------------------------- Distance;Manque -------------------------------- -->

                    <div
                      *ngSwitchCase="'Distance;Manque'"
                      class="flex flex-col justify-evenly"
                    >
                      <ng-container formGroupName="{{ critere.critereId }}">
                        <ng-container formArrayName="valueCritere">
                          <ng-container
                            *ngFor="
                              let control of valuesCritere(critere.critereId)
                                .controls;
                              index as i
                            "
                          >
                            <mat-form-field>
                              <input
                                matInput
                                type="number"
                                placeholder="{{
                                  critere.typeObservation.split(';')[i]
                                }}"
                                required
                                [formControlName]="i"
                              />
                            </mat-form-field>
                          </ng-container>
                        </ng-container>
                      </ng-container>
                    </div>
                    <!-- -------------------------------- Dim excès;Dim rentrant -------------------------------- -->

                    <div
                      *ngSwitchCase="'Dim excès;Dim rentrant'"
                      class="flex flex-col justify-evenly"
                    >
                      <ng-container formGroupName="{{ critere.critereId }}">
                        <ng-container formArrayName="valueCritere">
                          <ng-container
                            *ngFor="
                              let control of valuesCritere(critere.critereId)
                                .controls;
                              index as i
                            "
                          >
                            <mat-form-field>
                              <input
                                matInput
                                type="number"
                                placeholder="{{
                                  critere.typeObservation.split(';')[i]
                                }}"
                                required
                                [formControlName]="i"
                              />
                            </mat-form-field> </ng-container
                        ></ng-container>
                      </ng-container>
                    </div>
                    <!-- -------------------------------- Dim délam;Dim arrache -------------------------------- -->

                    <div
                      *ngSwitchCase="'Dim délam;Dim arrache'"
                      class="flex flex-col justify-evenly"
                    >
                      <ng-container formGroupName="{{ critere.critereId }}">
                        <ng-container formArrayName="valueCritere">
                          <ng-container
                            *ngFor="
                              let control of valuesCritere(critere.critereId)
                                .controls;
                              index as i
                            "
                          >
                            <mat-form-field>
                              <input
                                matInput
                                type="number"
                                placeholder="{{
                                  critere.typeObservation.split(';')[i]
                                }}"
                                required
                                [formControlName]="i"
                              />
                            </mat-form-field> </ng-container
                        ></ng-container>
                      </ng-container>
                    </div>

                    <!-- -------------------------------- Dim;Couleur -------------------------------- -->

                    <div
                      *ngSwitchCase="'Dim;Couleur'"
                      class="flex flex-col justify-evenly"
                    >
                      <ng-container formGroupName="{{ critere.critereId }}">
                        <ng-container formArrayName="valueCritere">
                          <ng-container
                            *ngFor="
                              let control of valuesCritere(critere.critereId)
                                .controls;
                              index as i
                            "
                          >
                            <mat-form-field>
                              <input
                                matInput
                                type="text"
                                placeholder="{{
                                  critere.typeObservation.split(';')[i]
                                }}"
                                required
                                [formControlName]="i"
                              />
                            </mat-form-field> </ng-container
                        ></ng-container>
                      </ng-container>
                    </div>
                    <!-- -------------------------------- #R43;#DOT24;#CCC;#inmetro -------------------------------- -->

                    <div
                      *ngSwitchCase="'#R43;#DOT24;#CCC;#inmetro'"
                      class="flex flex-col justify-evenly"
                    >
                      <ng-container formGroupName="{{ critere.critereId }}">
                        <ng-container formArrayName="valueCritere">
                          <ng-container
                            *ngFor="
                              let control of valuesCritere(critere.critereId)
                                .controls;
                              index as i
                            "
                          >
                            <mat-form-field>
                              <input
                                matInput
                                type="text"
                                placeholder="{{
                                  critere.typeObservation.split(';')[i]
                                }}"
                                required
                                [formControlName]="i"
                              />
                            </mat-form-field>
                          </ng-container>
                        </ng-container>
                      </ng-container>
                    </div>

                    <!-- --------------------- Dim conducteur;Dim passager --------------------- -->

                    <div
                      *ngSwitchCase="'Dim conducteur;Dim passager'"
                      class="flex flex-col justify-evenly"
                    >
                      <ng-container formGroupName="{{ critere.critereId }}">
                        <ng-container formArrayName="valueCritere">
                          <ng-container
                            *ngFor="
                              let control of valuesCritere(critere.critereId)
                                .controls;
                              index as i
                            "
                          >
                            <mat-form-field>
                              <input
                                matInput
                                type="number"
                                placeholder="{{
                                  critere.typeObservation.split(';')[i]
                                }}"
                                required
                                [formControlName]="i"
                              />
                            </mat-form-field>
                          </ng-container>
                        </ng-container>
                      </ng-container>
                    </div>
                    <!-- ---------------------Critère;Observations --------------------- -->

                    <div
                      *ngSwitchCase="'Critère;Observations'"
                      class="flex flex-col justify-evenly"
                    >
                      <ng-container formGroupName="{{ critere.critereId }}">
                        <ng-container formArrayName="valueCritere">
                          <ng-container
                            *ngFor="
                              let control of valuesCritere(critere.critereId)
                                .controls;
                              index as i
                            "
                          >
                            <mat-form-field>
                              <input
                                matInput
                                type="number"
                                placeholder="{{
                                  critere.typeObservation.split(';')[i]
                                }}"
                                required
                                [formControlName]="i"
                              />
                            </mat-form-field>
                          </ng-container>
                        </ng-container>
                      </ng-container>
                    </div>
                  </div>
                </td>

                <ng-container *ngIf="auditReceived == undefined">
                  <td>
                    <mat-form-field>
                      <input
                        matTooltip="{{ critere.infoDemerite }}"
                        matInput
                        min="0"
                        step="1"
                        type="number"
                        (change)="demeriteChanged($event, critere, 20)"
                      />
                    </mat-form-field>
                  </td>
                  <td>
                    <mat-form-field>
                      <input
                        matTooltip="{{ critere.infoDemerite }}"
                        matInput
                        min="0"
                        step="1"
                        type="number"
                        (change)="demeriteChanged($event, critere, 10)"
                      />
                    </mat-form-field>
                  </td>
                  <td>
                    <mat-form-field>
                      <input
                        matTooltip="{{ critere.infoDemerite }}"
                        matInput
                        min="0"
                        step="1"
                        type="number"
                        (change)="demeriteChanged($event, critere, 5)"
                      />
                    </mat-form-field>
                  </td>
                  <td>
                    <mat-form-field>
                      <input
                        matTooltip="{{ critere.infoDemerite }}"
                        matInput
                        min="0"
                        step="1"
                        type="number"
                        (change)="demeriteChanged($event, critere, 3)"
                      />
                    </mat-form-field>
                  </td>
                  <td>
                    <mat-form-field>
                      <input
                        matTooltip="{{ critere.infoDemerite }}"
                        matInput
                        min="0"
                        step="1"
                        type="number"
                        (change)="demeriteChanged($event, critere, 1)"
                      />
                    </mat-form-field>
                  </td>
                  <td>{{ demeriteTotal(critere) || undefined }}</td>
                </ng-container>
              </tr>
            </ng-template>
          </p-table>
        </div>
      </div>
    </mat-card-content>
  </form>
</mat-card>
